PhosphorusMonomer
Date: 2019-10-22

org.jmol.modelsetbio

## Class PhosphorusMonomer

- java.lang.Object
- - org.jmol.modelset.Group
  - - org.jmol.modelsetbio.Monomer
    - - org.jmol.modelsetbio.PhosphorusMonomer

- All Implemented Interfaces:
    Structure
  Direct Known Subclasses:
    NucleicMonomer

      public class PhosphorusMonomer
      extends Monomer

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private static float` | `MAX_ADJACENT_PHOSPHORUS_DISTANCE`
    `protected static byte` | `P`
    `private static byte[]` | `phosphorusOffsets`

    - ### Fields inherited from class org.jmol.modelsetbio.Monomer

      `backboneBlockVis, bioPolymer, monomerIndex, offsets`

    - ### Fields inherited from class org.jmol.modelset.Group

      `chain, dssrNT, firstAtomIndex, group1, group3Names, groupID, groupIndex, lastAtomIndex, leadAtomIndex, selectedIndex, seqcode, shapeVisibilityFlags, specialAtomNames, standardGroupList`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `PhosphorusMonomer()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.Object` | `getHelixData(int tokType, char qType, int mStep)`
    `STR` | `getProteinStructureType()`
    `javajs.util.Quat` | `getQuaternion(char qType)`
    `(package private) javajs.util.P3` | `getQuaternionFrameCenter(char qType)`
    `protected javajs.util.Quat` | `getQuaternionP()`
    `Structure` | `getStructure()`
    `protected boolean` | `isCA2(Monomer possiblyPreviousMonomer)`
    `(package private) boolean` | `isConnectedAfter(Monomer possiblyPreviousMonomer)`
    `boolean` | `isDna()` group ID-based definition
    `boolean` | `isNucleic()` group ID-based definition
    `boolean` | `isPurine()` group ID-based definition
    `boolean` | `isPyrimidine()` group ID-based definition
    `boolean` | `isRna()` group ID-based definition
    `(package private) static Monomer` | `validateAndAllocateP(Chain chain, java.lang.String group3, int seqcode, int firstIndex, int lastIndex, int[] specialAtomIndexes)`

    - ### Methods inherited from class org.jmol.modelsetbio.Monomer

      `checkOptional, findNearestAtomIndex, getAtomFromOffsetIndex, getAtomIndex, getBioPolymerIndexInModel, getBioPolymerLength, getCrossLinkGroup, getCrossLinkVector, getGroup1, getGroup1b, getGroupParameter, getHelixData2, getInitiatorAtom, getLeadAtom, getMonomerIndex, getMonomerSequenceAtoms, getMyInfo, getSelectedMonomerCount, getSelectedMonomerIndex, getSpecialAtom, getSpecialAtomPoint, getStructureId, getTerminatorAtom, getUniqueID, getWingAtom, have, isConnectedPrevious, isCrossLinked, isHelix, isLeadAtom, isSheet, scanForOffsets, set2, setBioPolymer, setGroupID, setGroupParameter, setLeadAtomIndex, setStrucNo, updateOffsetsForAlternativeLocations`

    - ### Methods inherited from class org.jmol.modelset.Group

      `addAtoms, fixIndices, getBSSideChain, getCarbonylOxygenAtom, getGroup3, getGroupInfo, getInsCode, getInsertionCode, getInsertionCodeChar, getInsertionCodeFor, getLeadAtomOr, getMinZ, getModel, getNitrogenAtom, getProteinStructureSubType, getProteinStructureTag, getQuaternionFrame, getResno, getSeqcodeFor, getSeqcodeString, getSeqcodeStringFor, getSeqNumberFor, getStrucNo, haveSequenceNumber, isAdded, isCarbohydrate, isCursorOnTopOf, isDnaByID, isNucleicMonomer, isProtein, isPurineByID, isPyrimidineByID, isRnaByID, isSelected, isWithinStructure, scaleToScreen, setAtomBits, setAtomBitsAndClear, setGroup, setProteinStructureType, setResno, setShapeVisibility, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### P

          protected static final byte P

      See Also:
        Constant Field Values

    - #### phosphorusOffsets

          private static final byte[] phosphorusOffsets

    - #### MAX_ADJACENT_PHOSPHORUS_DISTANCE

          private static float MAX_ADJACENT_PHOSPHORUS_DISTANCE

  - ### Constructor Detail

    - #### PhosphorusMonomer

          protected PhosphorusMonomer()

  - ### Method Detail

    - #### isNucleic

          public final boolean isNucleic()

      Description copied from class: `Group`
      group ID-based definition
      Overrides:
        `isNucleic` in class `Group`
      Returns:
        boolean

    - #### validateAndAllocateP

          static Monomer validateAndAllocateP(Chain chain,
                                              java.lang.String group3,
                                              int seqcode,
                                              int firstIndex,
                                              int lastIndex,
                                              int[] specialAtomIndexes)

    - #### isDna

          public boolean isDna()

      Description copied from class: `Group`
      group ID-based definition
      Overrides:
        `isDna` in class `Group`
      Returns:
        boolean

    - #### isRna

          public boolean isRna()

      Description copied from class: `Group`
      group ID-based definition
      Overrides:
        `isRna` in class `Group`
      Returns:
        boolean

    - #### isPurine

          public boolean isPurine()

      Description copied from class: `Group`
      group ID-based definition
      Overrides:
        `isPurine` in class `Group`
      Returns:
        boolean

    - #### isPyrimidine

          public boolean isPyrimidine()

      Description copied from class: `Group`
      group ID-based definition
      Overrides:
        `isPyrimidine` in class `Group`
      Returns:
        boolean

    - #### getStructure

          public Structure getStructure()

      Overrides:
        `getStructure` in class `Group`

    - #### getProteinStructureType

          public STR getProteinStructureType()

      Overrides:
        `getProteinStructureType` in class `Monomer`

    - #### isConnectedAfter

          boolean isConnectedAfter(Monomer possiblyPreviousMonomer)

      Specified by:
        `isConnectedAfter` in class `Monomer`

    - #### isCA2

          protected boolean isCA2(Monomer possiblyPreviousMonomer)

    - #### getQuaternion

          public javajs.util.Quat getQuaternion(char qType)

      Overrides:
        `getQuaternion` in class `Group`
      Returns:
        quaternion

    - #### getQuaternionP

          protected javajs.util.Quat getQuaternionP()

    - #### getQuaternionFrameCenter

          javajs.util.P3 getQuaternionFrameCenter(char qType)

      Overrides:
        `getQuaternionFrameCenter` in class `Monomer`
      Returns:
        center

    - #### getHelixData

          public java.lang.Object getHelixData(int tokType,
                                               char qType,
                                               int mStep)

      Overrides:
        `getHelixData` in class `Group`
      Returns:
        helix data of some sort